CHANGELOG
=========

###	Alpha version development started August 18, 2023
###	Developed by Veer and Saad Mehmood at XenCustomize.com
###	Effortlessly set download limits, complemented by user-friendly error pages & informative interfaces.
###	License: Single-use License (1 License, 1 website). The product is provided AS-IS, no promises for additional features or functionality.
###	Updates duration: 6 Months / $15 Renewal
###	Visible branding: Yes, but removable with payment ($15 USD)
###	Requires XenForo 2.2.4+, XFRM 2.2.2+



###	1.1.5 (December 06, 2023)
###	==================================== CHANGELOG FOR 1.1.5 =======================================

-	Resolved an issue where the User group permission "Countdown timer time" was not being applied on the front-end.



###	1.1.4 (November 01, 2023)
###	==================================== CHANGELOG FOR 1.1.4 =======================================

-	Resources with the "External Download URL" type now support:
	- Download limit
	- Countdown timer
-	Auto-watch resources when downloading using the countdown timer.
-	User group permissions related to moderators are now separated.
-	Several important fixes and stability improvements.



###	1.1.3 (October 31, 2023)
###	==================================== CHANGELOG FOR 1.1.3 =======================================

-	Resolved an `[E_WARNING] Attempt to read property "Container" on null` error, allowing users to download resources with "External Download URL" without issues.
	-	Notes:
		- Resources with "External Download URL" now support:
			- Positive reaction limit.
			- Message count limit.
		- Resources with "External Download URL" do not support:
			- Download limit.
			- Countdown timer.



###	1.1.2.1 (October 13, 2023)
###	==================================== CHANGELOG FOR 1.1.2.1 =====================================

-	We took out the emoji from these phrases:
	- xcu_lrdl_reaction_limit_overview
	- xcu_lrdl_reaction_limit_not_applied



###	1.1.2 (October 7, 2023)
###	==================================== CHANGELOG FOR 1.1.2 =======================================

-	JavaScript has been rewritten to make it native, (no longer relies on jQuery) in preparation for removal of jQuery in XenForo 2.3.
-	The add-on detects XenForo version and serves the appropriate JavaScript code, ensuring compatibility with both XF 2.2 and 2.3.



###	1.1.1 (September 3, 2023)
###	==================================== CHANGELOG FOR 1.1.1 =======================================

-	Implemented Page Visibility API to pause the countdown timer when user switches to another tab.



###	1.1.0 (September 1, 2023)
###	==================================== CHANGELOG FOR 1.1.0 =======================================

-	Implemented a download countdown timer before displaying the download button.
-	Introduced a new download page that showcases:
	-	Countdown timer
	-	File name
	-	File size
	-	File extension
	-	File view count
	-	Multiple ad positions
	-	Sidebar widget position
	-	Click to Go back button
	-	Limits overview button
-	Admin option to set the default number of seconds that users should wait before initiating the download:
	-	Countdown Timer Time in Seconds.
-	Added usergroup permission to customize "Countdown Timer Time" per usergroup, overriding the admin default:
	-	Countdown timer time.
-	Included a couple of XenForo native ad positions for placing advertisements on the download countdown timer page:
	-	Limit Resource Downloads: Countdown timer above download.
	-	Limit Resource Downloads: Countdown timer below download.
-	Added new widget position to place widgets in the sidebar position on the download countdown timer page:
	-	Limit resource downloads: Countdown timer.
-	Included additional new templates and phrases.



###	1.1.0 Beta 2 (August 30, 2023)
###	==================================== IMPLEMENTED FEATURES FOR 1.1.0 Beta 2 ============================

-	Implemented restrictions on changing or undoing reactions, as suggested by @SelamT
-	Introduced separate options for admins to easily activate restrictions on "Changing Reactions" and "Undoing Reactions.
	-	Reactions change restriction
	-	Reactions undo restriction
-	Added 2 new usergroup permissions to override option settings and enable changing or undoing reactions for different user groups:
	-	Can change reaction
	-	Can undo reaction
-	The new permissions are automatically applied during the post-upgrade process.
-	Included additional new phrases.
-	Fixed a bug in 1.1.0 Beta 1 where a template was missing, preventing display of Positive Reaction error on History tab version download.



###	1.1.0 Beta 1 (August 28, 2023)
###	==================================== IMPLEMENTED FEATURES FOR 1.1.0 Beta 1 ============================

-	Implemented Positive Reaction Limit, suggested by @SelamT
-	Added an option for admins to specify multiple "Positive Reaction IDs" with ease.
-	Introduced a new user-friendly error page to guide users when they've reacted, but not with a positive reaction.
-	Retained the familiar "Oops! You forgot to react" error page for cases where users attempt to download without giving any reaction.
-	Extended Positive Reaction Limit to Version Download links on the History tab, along with the corresponding error page.
-	Revised template names and phrase titles for consistent terminology.
-	Additional new templates and phrases.



###	1.0.2 (August 26, 2023)
###	==================================== IMPLEMENTED CHANGES FOR 1.0.2 ====================================

+	Added custom classes and style properties for effortless customization of Info Tabs Bar, Custom Buttons, and Download Limits Overview:
	+	Button Caution
	+	Button Negative
	+	Button Positive
	+	Info Tabs Bar
		+	Positive color
		+	Negative color
		+	Caution color
+	All templates now utilize the <xf:fa> template syntax tag for Font Awesome icons.
+	Added a few missing phrases.
+	Corrected a bug within the "Download Limits Overview" page where the wrong phrase was used.


###	1.0.1 (August 25, 2023)
###	==================================== IMPLEMENTED FEATURES FOR 1.0.1 ====================================

+	Resolved all identified bugs in version 1.0.0.
+	Conducted thorough code cleanup and fine-tuned template conditions.
+	Enhanced the design of the Download Limits Overview page/popup window.
+	Implemented the inclusion of phrases in templates to facilitate seamless translation.
+	Carefully verified all permissions and significantly improved the functionality of the force account upgrade on the front-end.
+	Made specific code changes to rectify the bug related to Download versions in the History tab.
+	Added a new template designed to display user-friendly error and informative messages when Download link is accessed from History tab.
+	Ensured consistency by renaming permissions.


###	1.0.0 (August 23, 2023)
###	==================================== IMPLEMENTED FEATURES FOR 1.0.0 ====================================

1.	Implemented up to 6 usergroup permissions for configuring download limits and bypass options.
	1)	Download limit
	2)	Message count limit
	3)	Reaction limit
	4)	Can bypass reaction limit
	5)	Can bypass message count limit
	6)	Force account upgrade

2.	Implemented support for setting permissions in each Resource Category.

3.	Implemented the following types of limits:
	1)	Customizable download limit/quota for a specified number of hours (default: 24 hours)
	2)	Reaction limit to prevent downloads without reacting to the resource.
	3)	Message count limit - admin-defined minimum messages required for each usergroup to access downloads.
	4)	Force account upgrade, replacing the download button with an account upgrade link.

4.	Implemented the ability to bypass the above limits:
	1)	Ability to set "Unlimited" in the download limit/quota to bypass download limits.
	2)	"Can bypass reaction limit" permission to bypass reaction limits.
	3)	"Unlimited" or "Can bypass message count limit" usergroup permission to bypass message count limits.

5.	Implemented Info Tabs Bar displaying a quick overview of the user's current download limits for the viewed resource.
	1)	Responsive Info Tabs Bar with scrolling, similar to Resource Tabs in standard XFRM.
	2)	Option to enable/disable via admin settings (Enabled by default).

6.	Implemented a "Download Limits Overview" page offering a detailed overview of user-specific download limits for the accessed resource.
	1)	Detailed overview and various info messages in the download limit section based on scenarios:
		1)	Download Limit
		2)	Downloads Left
		3)	Download Limit Reset Time
	2)	Detailed info messages in the message count limit section based on scenarios:
		1)	Message Count Limit
		2)	User Message Count
	3)	Detailed explanation of how the reaction limit is applied to the user in the reaction limit section.

7.	Implemented Custom Buttons integrated with the Download button to provide quick user info/alerts:
	1)	"Downloads Left" counter (visible when users have remaining download quota)
	2)	"Download Limit Exceeded" alert (visible when users have used their download quota)
	3)	"Upgrade your account to download" (visible when Force Account Upgrade permission is active for the user)
	4)	"Upgrade account" (visible when Download Limit is exceeded for the user)

8.	Implemented user-friendly error pages explaining and guiding users through download limits and restrictions:
	1)	Reaction Limit Error Page with an Encouraging Title, Message, and Custom Buttons: "Click to Go Back" and "Learn More"
	2)	Message Count Limit Error Page with an Encouraging Title, Message, and Custom Buttons: "Click to Go Back" and "Learn More"
	3)	Force Account Upgrade Error Page with an Encouraging Title, Message, and Custom buttons "Click to Go Back" and "Available Upgrades" linked to account upgrades.

9.	Implemented Admin options for customizable control:
	1)	Download Limit Reset Time in Hours.
	2)	Enable Download Limits Quick Info Tab Bar.
	3)	Enable Download Limits Detailed Overview Page.

10.	Implemented limits on Version Downloads on the History tab.
